import create from 'dd-store';
import { checkFullScren } from "../../utils/checkFullScren";
import pageStore from './store';
import { saveFileInfo, getMeetingRoomAffairs, createMeetingTask, deleteMeetingTask, updateMeetingTask, uploadPermissions } from '../../api/request';
import { getOssPermission, getuploadResource, isParticipate, deleteSchedule, getScheduleDetail, getUserScheduleInTime, modifySchedule, getMeetingRoomRepeatAffairs, updateMoment, deleteMoment } from '../../api/request.js'
import { selectedelRequired, selectPeople, getShowTime, modifyTimeImpactRepeat, throttle, getCreateShowTime, dealRepeatModal } from './../../utils/utils.js'
import { observer } from '/utils/observer.js'
import { resolve } from 'path';
import { getFileInfo, aheadTimesList, getFileInfoFromOss } from './uploadFile.js';
import { repeatList } from '../createMeeting/constant';
import { aheadTimeList, participateStatusList, noParticipateStatusList, centerPopupList, editSaveList } from './constant';
import { getSelectRepeatId, getInitialPsarticipants, handleChangePeople } from './utils'
create.Page({
  store: pageStore,
  useAll: true,
  data: {
    current: 1,
    pages: 1,
    isIPX: false,
    $data: null,
    affairLoading: true,
    affairList: null, //store,页面用到的变量需要在这里声明
    show: false, //pop
    oldTask: null,
    // pop: {
    //   title: '',
    //   type: ''
    // },
    loading: false,
    // 传给组件list 的所有数据 comListData
    comListData: {
      complete: false,
      // aheadTimesListId: [15],
      comSelectListId: 0,
      meetingWayModelId: null,
      iconType: 'icon'
    },

    conToastData: {
      showToast: false,
      title: '保存成功'
    },
    // 传递给组件selectPopup 的数据
    conSelectPopupData: {
      showSelectPopup: false,
      selectType: 'common',
      selectPopupId: '',
      // editSaveList: [{ text: '仅保存此会议', id: 'only' }, { text: '保存此次及以后会议', id: 'future' }],
      delSheudleList: [{ text: '仅删除此会议', id: 'only' }, { text: '删除此次及以后会议', id: 'future' }],
      // participateStatusList: [{ text: '仅参加此次会议', id: 'only' }, { text: '参加所有会议', id: 'all' }],
      // noParticipateStatusList: [{ text: '不参加此次会议', id: 'only' }, { text: '不参加所有会议', id: 'all' }]
    },
    // 传递给组件centerPopup 的数据
    // centerPopup: {
    //   showCenterPopup: false,
    //   centerPopupList: [
    //     { id: 0, text: '不发送通知' },
    //     { id: 1, text: '发送通知' }
    //   ],
    // },

    title: ``,
    meetingRemark: '',
    isShowRemark: false,
    showTime: '',
    repeat: {
      repeatList: repeatList,
      recurrenceModel: { model: 'no_repeat' },
      repeatable: 0,
      selectRepeatId: 0
    },
    popup: {
      show: false,
      title: '',
      mask: '',
      type: 'modify_location'
    },
    organizer: '',
    currentPeople: '',
    scheduleItem: '',
    isExpand: false,
    confirmAttendance: null,
    aheadTime: {
      aheadTimeList: aheadTimeList,
      aheadTimes: [15],
      iconType: 'icon',
      aheadTimesListId: [15],
    },
    selectPopup: {
      show: false,
      list: participateStatusList,
      type: ''
    },
    centerPopup: {
      show: false,
      list: centerPopupList,
      type: 'modify_location'
    },
    needNotice: 0,






    repeatWeek: ['SU', 'MO', 'TU', 'WE', 'TH', 'FR', 'SA'],
    popupTitle: '会议重复',
    popupShow: false,
    comType: '',
    comTimeType: '',
    meetingWayModel: { model: null },
    weekList: ['周日', '周一', '周二', '周三', '周四', '周五', '周六'],
    week: '',
    conflictPeople: [],
    lock: false,
    // aheadTimes: [15],
    editType: '',
    placeholder: '',
    mrReserveStatus: '',
    id: ''
  },
  onShow() {
    this.update()

    if (this.store.data.isNeedReloadList) {
      this.loadAffairList();
      this.setData({
        'conToastData.showToast': true,
        'conToastData.title': '保存成功',
      });
      this.$store.data.isIndexAffairListNeedUpdate = true;
      this.update();
    }

    if (this.$store.data.updateInfo.isUpate) {
      if (this.$store.data.updateInfo.updateType === "modify_location") {
        this.setData({
          'centerPopup.show': true,
          'centerPopup.type': "modify_location"
        })
      }
      if (this.$store.data.updateInfo.updateType === 'operate_user') {
        this.handleParticipatorSave()
      }
      this.$store.data.updateInfo = {
        updateType: '',
        isUpate: false
      }
      this.update()
    }
  },
  onLoad(event) {
    event.scheduleItem = decodeURIComponent(event.scheduleItem);
    this.reset()
    dd.setNavigationBar({
      title: `会议详情`
    })
    this.setData({
      isIPX: checkFullScren(),
      placeholder: `${getApp().globalData.name}创建的会议`,
      scheduleItem: JSON.parse(event.scheduleItem),
      currentPeople: getApp().globalData.userid
    })
    this.getDetail()

    let scheduleItem = this.data.scheduleItem
    const _that = this
    observer.register({
      notice(scheduleItem) {
        _that.setData({
          'scheduleItem.scheduleTemplateId': scheduleItem
        })
      }
    })
  },
  // 获取详情
  getDetail() {
    let data = {
      id: !!this.data.scheduleItem.scheduleId ? this.data.scheduleItem.scheduleId : this.data.scheduleItem.id,
      scheduleTemplateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: !!this.data.scheduleItem.planDate ? this.data.scheduleItem.planDate.replace(/\//g, '-') : null
    }
    //动态列表进来的详情传groupId
    if (this.data.scheduleItem.groupId) {
      data.groupId = this.data.scheduleItem.groupId;
      delete data.id;
      delete data.planDate;
    }
    getScheduleDetail(data).then(res => {
      if (res.data.code !== 0) {
        return
      }
      if (!res.data.data.id) {
        console.log('详情接口scheduleId不存在')
        return
      }

      this.setData({
        scheduleItem: {
          id: res.data.data.id,
          scheduleTemplateId: res.data.data.scheduleTemplateId,
          planDate: res.data.data.planDate,
        },
        title: res.data.data.title,
        meetingRemark: res.data.data.remark,
        isShowRemark: res.data.data.remark ? true : false,
        showTime: getShowTime(res.data.data.startTime.replace(/-/g, "/"), res.data.data.endTime.replace(/-/g, "/")),
        repeat: {
          repeatable: res.data.data.repeatable,
          repeatList: repeatList,
          recurrenceModel: res.data.data.repeatable ? res.data.data.recurrenceModel : { model: 'no_repeat' },
          selectRepeatId: res.data.data.repeatable === 0 ? 0 : getSelectRepeatId(res.data.data.recurrenceModel, repeatList)
        },
        // organizer: res.data.data.organizer,
        organizer: getApp().globalData.userid,
        isExpand: res.data.data.confirmAttendance === 1 ? true : false,
        confirmAttendance: res.data.data.confirmAttendance === null ? -9 : res.data.data.confirmAttendance,
        aheadTime: {
          aheadTimeList: aheadTimeList,
          aheadTimes: !!res.data.data.aheadTimes ? res.data.data.aheadTimes : [],
          iconType: 'icon',
          aheadTimesListId: !!res.data.data.aheadTimes ? res.data.data.aheadTimes : [-1],
        }

      })

      this.$store.data.originalData = res.data.data
      this.$store.data.locationName = res.data.data.location.locationName
      this.$store.data.roomId = res.data.data.meetingRoomId < 0 ? '' : res.data.data.meetingRoomId
      this.store.data.scheduleId = res.data.data.groupId
      this.$store.data.startTime = res.data.data.startTime.replace(/-/g, "/")
      this.$store.data.endTime = res.data.data.endTime.replace(/-/g, "/")
      this.$store.data.participatorList = getInitialPsarticipants(res.data.data.userList)
      this.$store.data.showParticipatorList = Object.values(this.$store.data.participatorList)
      this.$store.data.originUsers = [...this.$store.data.showParticipatorList]

      this.update()
      this.loadAffairList();
    })
    // getScheduleDetail(data).then(res => {

    //   if (res.data.code === 0) {
    //     if (!res.data.data.id) {
    //       console.log('详情接口scheduleId不存在')
    //     }
    //     let participatorList = []
    //     let repeatListMap = new Map()
    //     for (let value of res.data.data.userList) {
    //       if (value.participator) {
    //         participatorList.push({ userId: value.participator.userId, username: value.participator.username, headUrl: value.participator.headUrl, platform: value.participator.platform })
    //         participatorUserId.push(value.participator.userId)
    //         originUsersId.push(value.participator.userId)
    //         originUsers.push({ userId: value.participator.userId, username: value.participator.username, headUrl: value.participator.headUrl, platform: value.participator.platform })
    //       }
    //     }
    //     for (let item of this.data.comListData.repeatList) {
    //       if (item.recurrenceModel.recurrenceModel !== 'weekly') {
    //         repeatListMap.set(item.recurrenceModel.model, item.id)
    //       }
    //     }
    //     this.setData({
    //       id: res.data.data.id,
    //       currentPeople: getApp().globalData.userid,
    //       aheadTimes: !!res.data.data.aheadTimes ? res.data.data.aheadTimes : [],
    //       'comListData.aheadTimesListId': !!res.data.data.aheadTimes ? res.data.data.aheadTimes : [-1],
    //       mrReserveStatus: res.data.data.mrReserveStatus,
    //       organizer: res.data.data.organizer,
    //       'comListData.meetingWayModelId': res.data.data.meetingWayModel.model === null ? null : (res.data.data.meetingWayModel.model === 'dingtalk' ? 0 : 1),
    //       repeatable: res.data.data.repeatable,
    //       recurrenceModel: res.data.data.repeatable ? { model: res.data.data.recurrenceModel.model, daysOfMonth: res.data.data.recurrenceModel.daysOfMonth, interval: 1, initialTime: res.data.data.recurrenceModel.initialTime, terminateTime: res.data.data.recurrenceModel.terminateTime, weekDayList: res.data.data.recurrenceModel.weekDayList } : { model: 'no_repeat' },
    //       title: res.data.data.title,
    //       remark: res.data.data.remark,
    //       isExpand: res.data.data.confirmAttendance === 1 ? true : false,
    //       isShowRemark: res.data.data.remark ? true : false,
    //       week: this.data.weekList[new Date(res.data.data.startTime.replace(/-/g, "/")).getDay()],
    //       getData: true,
    //       scheduleItem: res.data.data,
    //       meetingWayModelData: res.data.data.meetingWayModel
    //     })

    //     if (res.data.data.repeatable) {
    //       this.setData({
    //         'comListData.comSelectListId': res.data.data.recurrenceModel.model === 'weekly' ? (res.data.data.recurrenceModel.weekDayList.length > 1 ? 3 : 2) : repeatListMap.get(res.data.data.recurrenceModel.model),
    //       })
    //     }
    //     // this.$store.data.originalData = res.data.data
    //     // this.$store.data.originUsers = originUsers
    //     this.$store.data.locationName = res.data.data.location.locationName
    //     this.$store.data.roomId = res.data.data.meetingRoomId < 0 ? '' : res.data.data.meetingRoomId
    //     this.$store.data.startTime = res.data.data.startTime.replace(/-/g, "/")
    //     this.$store.data.endTime = res.data.data.endTime.replace(/-/g, "/")
    //     this.$store.data.participatorList = participatorList
    //     this.$store.data.participatorUserId = participatorUserId
    //     this.$store.data.originUsersId = originUsersId
    //     this.update()
    //     this.conflictPeople()
    //     this.store.data.scheduleId = res.data.data.id;
    //     this.store.data.groupId = res.data.data.groupId;
    //     this.update();
    //     this.loadAffairList();
    //     this.resetRepeatList()
    //     // if (res.data.data.meetingWayModel.model === 'zoom' && res.data.data.meetingWayModel.data === null) {
    //     //   setTimeout(() => {
    //     //     getScheduleDetail(data).then(success => {
    //     //       this.setData({
    //     //         meetingWayModelData: res.data.data.meetingWayModel
    //     //       })
    //     //     })
    //     //   }, 30000)
    //     // }
    //   }
    // })
  },

  // 添加标题
  handleChangeTitle(event) {
    this.setData({
      title: event.detail.value
    })
  },
  // 保存标题
  handleTitleSave() {
    const modifyModel = "only"
    let dataTitle = {
      title: this.data.title,
      modifyModel: modifyModel,
      modifyContent: 'title'
    }
    if (this.data.repeat.repeatable) {
      dataTitle.modifyModel = "future"
    }
    this.modifySchedule(dataTitle)
  },


  // 打开添加描述
  handleOpenRemark() {
    this.setData({
      isShowRemark: true
    })
  },
  // 添加描述
  handleChangeRemark(event) {
    this.setData({
      meetingRemark: event.detail.value
    })
  },
  // 保存添加描述
  handleRemarkSave() {
    const modifyModel = "only"
    let dataRemark = {
      remark: this.data.meetingRemark,
      modifyModel: modifyModel,
      modifyContent: 'remark'
    }
    if (this.data.repeat.repeatable) {
      dataRemark.modifyModel = "future"
    }
    this.modifySchedule(dataRemark)

  },


  // 跳转选择地点
  goSelectPlace() {
    dd.navigateTo({
      url: `./../place/place?scheduleItem=${encodeURIComponent(JSON.stringify(this.data.scheduleItem))}`
    })
  },
  // 删除地点
  handleDeletePlace() {
    this.$store.data.locationName = ''
    this.$store.data.roomId = ''
    this.update()
    this.setData({
      'centerPopup.show': true,
      'centerPopup.type': "modify_location"
    })
  },

  // 选择地点是否发送通知
  selectPlaceNeedNotice(event) {
    this.handleCloseCenterPopup()
    const needNotice = event.currentTarget.dataset.item.id
    if (this.data.repeat.repeatable == 0) {
      this.handlePlaceSave('only', needNotice)
      return
    }
    this.setData({
      needNotice: needNotice,
      selectPopup: {
        show: true,
        list: editSaveList,
        type: 'modify_location'
      }
    })
  },
  // 地点 保存此次还是以后
  selectSavePlaceStatus(event) {
    this.handleSelectPopupCancel()
    const modifyModel = event.currentTarget.dataset.item.id
    this.handlePlaceSave(modifyModel, this.data.needNotice)
  },
  // 保存地点
  handlePlaceSave(modifyModel = "only", needNotice = "Y") {
    let dataLocation = {
      modifyModel: modifyModel,
      needNotice: needNotice,
      modifyContent: 'modify_location',
      location: {
        longitude: '-999',
        latitude: '-999',
        locationName: this.$store.data.locationName
      },
      meetingRoomId: !!this.$store.data.roomId ? this.$store.data.roomId : -1
    }
    this.modifySchedule(dataLocation).then(res => {
      this.$store.data.updateInfo = {
        updateType: '',
        isUpate: false
      }
    })
  },

  // 关闭centerPopup
  handleCloseCenterPopup() {
    this.setData({
      centerPopup: {
        show: false,
        list: centerPopupList,
        type: ''
      }
    })
  },


  // 选择时间 打开popup
  handleTime() {
    this.setData({
      popup: {
        show: true,
        title: "选择会议时间",
        mask: true,
        type: 'time'
      }
    })
  },
  // 选择时间点击完成
  onComplete(event) {
    this.$store.data.startTime = `${event.startTime}:00`
    this.$store.data.endTime = `${event.endTime}:00`
    this.update()
    this.setData({
      showTime: getShowTime(this.$store.data.startTime, this.$store.data.endTime)
    })
    this.closePopup()
    this.handleTimeSave()

    /* 
    改时间 改掉重复规则
    先选重复规则 再改时间 重复规则也要改变
    暂时修改每周 每月重复问题
     */
    if (this.data.repeat.repeatable !== 0) {
      let recurrenceModel = modifyTimeImpactRepeat(this.data.repeat.recurrenceModel)
      this.setData({
        'repeat.recurrenceModel': recurrenceModel
      })
    }

  },
  // 保存时间
  handleTimeSave() {
    const modifyModel = "only"
    let data = {
      modifyModel: modifyModel,
      startTime: this.$store.data.startTime.replace(/\//g, "-"),
      endTime: this.$store.data.endTime.replace(/\//g, "-"),
      modifyContent: 'modify_time'
    }
    if (this.data.repeat.repeatable === 0) {
      this.modifySchedule(data)
    }

  },

  // 选择重复规则 打开popup
  handleRepeatModal() {
    this.setData({
      popup: {
        show: true,
        title: "重复规则",
        mask: true,
        type: 'repeat'
      }
    })
  },

  // 选择重复
  selectRepeatListItem(event) {
    const item = event.currentTarget.dataset.item
    const repeat = dealRepeatModal(item)
    this.setData({
      'repeat.repeatable': repeat.repeatable,
      'repeat.recurrenceModel': repeat.recurrenceModel,
      'repeat.selectRepeatId': repeat.selectRepeatId,
    })
    this.closePopup()
    this.handleRepeatSave()
  },
  //保存重复
  handleRepeatSave() {


  },


  // 添加参会人
  handleAddParticipator: throttle(async function () {
    let select = []
    let require = []
    if (this.data.organizer === this.data.currentPeople) {
      select = Object.keys(this.$store.data.participatorList)
      require = [this.data.currentPeople]
      select = selectedelRequired(select, require)
    } else {
      select = []
      require = Object.keys(this.$store.data.participatorList)
    }

    const showParticipatorList = this.$store.data.showParticipatorList
    selectPeople(select, require).then(res => {
      let participatorList = {}
      if (this.data.organizer === this.data.currentPeople) {
        participatorList[getApp().globalData.userid] = {
          userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk'
        }
      }

      if (this.data.organizer !== this.data.currentPeople) {
        for (let i = 0; i < this.$store.data.showParticipatorList.length; i++) {
          participatorList[showParticipatorList[i].userId] = { userId: showParticipatorList[i].userId, username: showParticipatorList[i].username, headUrl: showParticipatorList[i].headUrl, platform: 'dingtalk' }
        }
      }

      for (let i = 0; i < res.users.length; i++) {
        participatorList[res.users[i].userId] = { userId: res.users[i].userId, username: res.users[i].name, headUrl: res.users[i].avatar, platform: 'dingtalk' }
      }
      this.$store.data.participatorList = participatorList
      this.$store.data.showParticipatorList = Object.values(participatorList)
      this.update()
      this.handleParticipatorSave()
    })
  }),
  //保存参会人
  handleParticipatorSave() {
    const modifyModel = "only"
    const changePeople = handleChangePeople(this.$store.data.originUsers, this.$store.data.showParticipatorList)
    let dataUser = {
      addUserList: changePeople.add,
      deleteUserList: changePeople.del,
      modifyModel: modifyModel,
      modifyContent: 'operate_user'
    }
    if (this.data.repeat.repeatable === 0) {
      this.modifySchedule(dataUser).then(res => {
        this.$store.data.originUsers = Object.values(this.$store.data.participatorList)
      })
    }
  },
  // 参会人详情
  goParticipantsDetail() {
    dd.navigateTo({ url: `./../participantsDetail/participantsDetail?scheduleItem=${this.store.data.scheduleItem}&organizer=${this.data.organizer}` })
  },


  // 保存编辑
  modifySchedule(data) {
    let that = this
    let obj = {
      scheduleId: this.data.scheduleItem.id,
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate
    }
    return new Promise((resolve) => {
      modifySchedule(Object.assign(data, obj)).then(res => {
        if (res.data.code !== 0) {
          dd.alert({
            content: '保存失败'
          })
          return
        }
        if (this.$store.modifyErpeatMeeting) {
          this.$store.modifyErpeatMeeting()
        }
        // if (data.modifyContent !== 'title') {
        //   if (this.$store.modifyErpeatMeeting) {
        //     this.$store.modifyErpeatMeeting()
        //   }
        // }
        if (this.data.repeat.repeatable === 1 && !!res.data.data) {
          observer.notice(res.data.data)
        }
        // if (data.modifyContent == 'modify_time' || data.modifyContent == ' modify_location') {
        //   this.setData({
        //     mrReserveStatus: res.data.extra
        //   })
        //   this.$store.data.originalData.mrReserveStatus = res.data.extra
        //   this.update()
        // }
        resolve(res)
      })

    })

  },

  // 删除 日程
  handleDelete() {
    const _that = this
    const modifyModel = "only"
    if (this.data.repeat.repeatable === 0) {
      dd.confirm({
        title: '删除会议',
        content: '确认删除会议吗？',
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        success: (success) => {
          if (!!success.confirm) {
            dd.showLoading({
              content: '正在删除...',
            });
            let data = {
              scheduleId: this.data.scheduleItem.id,
              identify: this.data.organizer === getApp().globalData.userid ? 'major' : 'identify',
              deleteModel: 'only'
            }
            deleteSchedule(data).then(async () => {
              if (this.$store.modifyErpeatMeeting) {
                await this.$store.modifyErpeatMeeting()
              }
              _that.$store.data.isIndexAffairListNeedUpdate = true;
              _that.update()
              dd.hideLoading()
              dd.navigateBack({
                delta: 1
              })
            })
          }
        }
      })
    }
    // if (this.data.repeatable) {
    //   this.setData({
    //     'conSelectPopupData.selectType': 'delSheudle',
    //     'conSelectPopupData.showSelectPopup': true
    //   })
    // }
  },

  //选择会前题醒打开popup
  handleAheadTime() {
    this.setData({
      popup: {
        show: true,
        title: "会前提醒",
        mask: true,
        type: 'aheadTime'
      }
    })
  },
  handleAheadTimeSave(event) {
    this.closePopup()
    this.setData({
      'aheadTime.aheadTimes': event,
      'aheadTime.aheadTimesListId.': event,
    })
    let modifyModel = "only"
    if (this.data.repeat.repeatable !== 0) {
      modifyModel = "all"
    }
    let dataAheadTime = {
      modifyModel: modifyModel,
      aheadTimes: this.data.aheadTime.aheadTimes,
      modifyContent: 'aheadTimes'
    }
    this.modifySchedule(dataAheadTime)
  },

  // 点击参加
  handleParticipate() {
    let dataParticipate = {
      scheduleId: this.data.scheduleItem.id,
      value: 1,
      type: 'only'
    }
    if (this.data.repeat.repeatable !== 0) {
      this.setData({
        selectPopup: {
          show: true,
          list: participateStatusList,
          type: "participateState"
        }
      })
      return
    }
    this.participateSave(dataParticipate)
  },
  // 点击 不参加
  handleNoParticipate() {
    let dataNoParticipate = {
      scheduleId: this.data.scheduleItem.id,
      value: 0,
      type: 'only'
    }
    if (this.data.repeat.repeatable !== 0) {
      this.setData({
        selectPopup: {
          show: true,
          list: noParticipateStatusList,
          type: "participateState"
        }
      })
      return
    }
    this.participateSave(dataNoParticipate)
  },
  // 重复 选择参加 不参加
  selectParticipateStatus(event) {
    this.handleSelectPopupCancel()
    const item = event.currentTarget.dataset.item
    let dataParticipate = {
      scheduleId: this.data.scheduleItem.id,
      type: item.id,
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate,
      value: item.value
    }
    this.participateSave(dataParticipate)
  },
  // 回到初始状态
  initialState() {
    let data = {
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate,
      scheduleId: this.data.scheduleItem.id,
      value: -9,
      type: 'only'
    }
    if (this.data.repeat.repeatable === 1) {
      data.type = 'all'
    }

    isParticipate(data).then(res => {
      if (res.data.code !== 0) {
        console.log(res)
        return
      }
      this.setData({
        confirmAttendance: -9
      })
      if (this.data.repeat.repeatable === 1) {
        if (this.$store.modifyErpeatMeeting) {
          this.$store.modifyErpeatMeeting()
        }
        return
      }
      if (this.$store.modifyOnceMeetingContent) {
        this.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: -9 })
      }
    })
  },
  // 参加状态保存 
  participateSave(dataParticipate) {
    return new Promise((resolve) => {
      isParticipate(dataParticipate).then(res => {
        resolve(res)
        if (res.data.code !== 0) {
          console.log(res)
          return
        }
        this.setData({
          'aheadTime.aheadTimes': [15],
          'aheadTime.aheadTimesListId': [15],
          confirmAttendance: dataParticipate.value
        })
        if (dataParticipate.type === "only") {
          if (this.$store.modifyOnceMeetingContent) {
            this.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: dataParticipate.value })
          }
          return
        }
        if (this.$store.modifyErpeatMeeting) {
          this.$store.modifyErpeatMeeting()
        }
      })

    })
  },

  // 关闭handleSelectPopupCancel
  handleSelectPopupCancel() {
    this.setData({
      selectPopup: {
        show: false,
        list: "",
        type: ""
      }
    })
  },
  // 关闭popup
  closePopup() {
    this.setData({
      popup: {
        show: false,
        title: "",
        mask: true,
        type: ''
      }
    })
  },




  // 初始化
  reset() {
    this.$store.resetEditData()
    this.store.data.affairList = [];
  },
  // // 选择循环机制 选择会议方式  选择时间  会前提醒 出现popup弹窗
  // showPopup(event) {
  //   let iconType = ''
  //   let complete = false
  //   let multiple = false
  //   let popupTitle = ''
  //   switch (event.currentTarget.dataset.type) {
  //     // case 'meetingWayModel':
  //     //   iconType = 'image',
  //     //     complete = true,
  //     //     popupTitle = '选择会议方式',
  //     //     multiple = false
  //     //   break
  //     case 'repeat':
  //       iconType = 'icon',
  //         popupTitle = '会议重复',
  //         complete = true,
  //         multiple = false
  //       break
  //     case 'participator':
  //       popupTitle = '选择参会人'
  //       break
  //     case 'time':
  //       popupTitle = '选择会议时间'
  //       break
  //     case 'aheadTime':
  //       popupTitle = '选择会前提醒'
  //       iconType = 'icon',
  //         complete = true,
  //         multiple = true
  //       break
  //   }
  //   this.setData({
  //     popupShow: true,
  //     popupTitle: popupTitle,
  //     comType: event.currentTarget.dataset.type,
  //     'comListData.complete': complete,
  //     'comListData.iconType': iconType,
  //     'comListData.multiple': multiple
  //   })
  // },
  // // 选择完comList后的回调 重复 会议方式
  // selectComList(event) {
  //   switch (this.data.comType) {
  //     case 'meetingWayModel':
  //       this.setData({
  //         'comListData.meetingWayModelId': event.currentTarget.dataset.item.id,
  //         popupShow: false,
  //         meetingWayModel: this.data.comListData.meetingWayList[event.currentTarget.dataset.item.id].meetingWayModel
  //       })

  //       if (this.data.repeatable) {
  //         this.setData({
  //           editType: 'meeting_way'
  //         })
  //         this.isChange('meeting_way', 'future')
  //       } else {
  //         this.isChange('meeting_way', 'only')
  //       }
  //       break;
  //     case 'repeat':
  //       this.resetRepeatList()
  //       this.setData({
  //         popupShow: false,
  //         'conSelectPopupData.selectType': 'common',
  //         'comListData.comSelectListId': event.currentTarget.dataset.item.id,
  //         repeatable: event.currentTarget.dataset.item.repeatable,
  //         recurrenceModel: event.currentTarget.dataset.item.recurrenceModel
  //       })
  //       this.conflictPeople()
  //       if (this.$store.data.originalData.repeatable) {
  //         this.setData({
  //           'conSelectPopupData.showSelectPopup': true,
  //           editType: 'repeat'
  //         })
  //       } else {
  //         if (this.$store.data.participatorList.length < 2) {
  //           this.isChange('repeat', 'only')
  //         } else {
  //           this.setData({
  //             editType: 'repeat',
  //             'centerPopup.showCenterPopup': true
  //           })
  //         }

  //       }
  //       break;
  //   }
  // },


  // // 选择会前提醒时间
  // selectAheadtimes(event) {
  //   this.setData({
  //     aheadTimes: event,
  //     popupShow: false,
  //     'comListData.aheadTimesListId': event
  //   })
  //   if (this.data.repeatable) {
  //     this.setData({
  //       editType: 'aheadTimes'
  //     })
  //     this.isChange('aheadTimes', 'all')
  //   } else {
  //     this.isChange('aheadTimes', 'only')
  //   }
  // },



  // toast 消失之后的回调
  onToastHidden() {
    this.setData({
      'conToastData.showToast': false
    })
  },
  // onSelectPopup 选择完的回调
  onSelectPopup(event) {
    const _that = this
    switch (this.data.conSelectPopupData.selectType) {
      case 'common':
        if (this.data.editType === 'modify_location' || this.data.editType === 'modify_time' || this.data.editType === 'repeat') {
          if (this.$store.data.participatorList.length < 2) {
            this.isChange(this.data.editType, event.currentTarget.dataset.item.id)
          } else {
            this.setData({
              'centerPopup.showCenterPopup': true
            })
          }
        } else {
          this.isChange(this.data.editType, event.currentTarget.dataset.item.id)
        }
        break
      case 'noParticipateStatus':
        let data1 = {
          scheduleId: this.data.scheduleItem.id,
          type: event.currentTarget.dataset.item.id,
          templateId: this.data.scheduleItem.scheduleTemplateId,
          planDate: this.data.scheduleItem.planDate,
          value: 0
        }
        isParticipate(data1).then(res => {
          if (res.data.code === 0) {
            this.setData({
              confirmAttendance: 0
            })
            this.conflictPeople()
            if (data1.type === 'only') {
              if (this.$store.modifyOnceMeetingContent) {
                this.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: 0 })
              }
            } else {
              if (this.$store.modifyErpeatMeeting) {
                this.$store.modifyErpeatMeeting()
              }
            }
          }
        })
        break
      case 'participateStatus':
        let data = {
          scheduleId: this.data.scheduleItem.id,
          type: event.currentTarget.dataset.item.id,
          templateId: this.data.scheduleItem.scheduleTemplateId,
          planDate: this.data.scheduleItem.planDate,
          value: 1
        }
        isParticipate(data).then(res => {
          if (res.data.code === 0) {
            this.setData({
              aheadTimes: [15],
              'comListData.aheadTimesListId': [15],
              confirmAttendance: 1
            })
            // this.conflictPeople()
            if (data.type === 'only') {
              if (this.$store.modifyOnceMeetingContent) {
                this.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: 1 })
              }
            } else {
              if (this.$store.modifyErpeatMeeting) {
                this.$store.modifyErpeatMeeting()
              }
            }
          }
        })
        break
      case 'delSheudle':
        dd.confirm({
          title: '删除会议',
          content: '确认删除会议吗？',
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          success: (success) => {
            if (!!success.confirm) {
              dd.showLoading({
                content: '正在删除...',
              });
              let data = {
                scheduleId: this.data.scheduleItem.id,
                identify: this.data.organizer === getApp().globalData.userid ? 'major' : 'identify',
                deleteModel: event.currentTarget.dataset.item.id,
                templateId: this.data.scheduleItem.scheduleTemplateId,
                planDate: this.data.scheduleItem.planDate
              }
              deleteSchedule(data).then(async () => {
                if (this.$store.modifyErpeatMeeting) {
                  await this.$store.modifyErpeatMeeting()
                }
                _that.$store.data.isIndexAffairListNeedUpdate = true;
                _that.update()
                dd.hideLoading()
                dd.navigateBack({
                  delta: 1
                })
              })
            }
          }
        })
        break
    }
    this.setData({
      'conSelectPopupData.showSelectPopup': false,
      'conSelectPopupData.selectPopupId': event.currentTarget.dataset.item.id
    })
  },
  // 选择发不发通知 
  onSelectSend(event) {
    if (event.currentTarget.dataset.item.id > -1) {
      if (this.$store.data.originalData.repeatable === 1) {
        this.isChange(this.data.editType, this.data.conSelectPopupData.selectPopupId, event.currentTarget.dataset.item.id)
      } else {
        this.isChange(this.data.editType, 'only', event.currentTarget.dataset.item.id)
      }
    } else {
      switch (this.data.editType) {
        case 'operate_user':
          this.reSetUsers()
          break;
        case 'modify_location':
          this.reSetLocation()
          break;
        case 'modify_time':
          this.reSetTime()
          break;
      }
    }
    this.setData({
      'centerPopup.showCenterPopup': false
    })
  },
  // onSelectPopupCancel 点击取消 
  onSelectPopupCancel() {
    this.setData({
      'conSelectPopupData.showSelectPopup': false
    })
    switch (this.data.editType) {
      case 'modify_time':
        this.reSetTime()
        break
      case 'modify_location':
        this.reSetLocation()
        this.$store.data.updateInfo = {
          isUpate: false,
          updateType: ''
        }
        break
      case 'operate_user':
        this.reSetUsers()
        this.$store.data.updateInfo = {
          isUpate: false,
          updateType: ''
        }
        break
      case 'repeat':
        this.reSetRepeat()
        break
    }
  },
  // 判断数据发生改变 发生改变 请求
  // isChange(value, modifyModel, needNotice = 0) {
  //   let modifyContent = ''
  //   switch (value) {
  //     case 'title':
  //       if (this.data.title !== this.$store.data.originalData.title) {
  //         let dataTitle = {
  //           title: this.data.title,
  //           modifyModel: modifyModel,
  //           modifyContent: 'title'
  //         }
  //         this.modifySchedule(dataTitle).then(res => {
  //           this.$store.data.isIndexAffairListNeedUpdate = true;
  //           this.$store.data.originalData.title = this.data.title

  //           if (this.data.repeatable == 0) {
  //             if (this.$store.modifyOnceMeetingContent) {
  //               this.$store.modifyOnceMeetingContent({
  //                 id: this.data.scheduleItem.id,
  //                 title: this.data.title
  //               })
  //             }
  //           } else {
  //             if (this.$store.modifyErpeatMeeting) {
  //               this.$store.modifyErpeatMeeting()
  //             }
  //           }

  //           this.update()
  //         }).catch(err => {
  //           this.setData({
  //             title: this.$store.data.originalData.title
  //           })
  //         })
  //       }
  //       break
  //     case 'remark':
  //       if (this.data.remark !== this.$store.data.originalData.remark) {
  //         let dataRemark = {
  //           remark: this.data.remark,
  //           modifyModel: modifyModel,
  //           modifyContent: 'remark'
  //         }
  //         this.modifySchedule(dataRemark).then(res => {
  //           this.$store.data.originalData.remark = this.data.remark
  //           this.update()
  //         }).catch(err => {
  //           this.setData({
  //             remark: this.$store.data.originalData.remark
  //           })
  //         })
  //       }
  //       break

  //     case 'operate_user':
  //       if (JSON.stringify(this.$store.data.originUsers) != JSON.stringify(this.$store.data.participatorList)) {
  //         let addUserList = this.arrayPoor(this.$store.data.originUsers, this.$store.data.participatorList).addUserList
  //         let deleteUserList = this.arrayPoor(this.$store.data.originUsers, this.$store.data.participatorList).deleteUserList
  //         let dataUser = {
  //           addUserList: addUserList,
  //           deleteUserList: deleteUserList,
  //           modifyModel: modifyModel,
  //           modifyContent: 'operate_user'
  //         }
  //         this.modifySchedule(dataUser, needNotice).then(res => {
  //           this.$store.data.originUsers = [...this.$store.data.participatorList]
  //           this.$store.data.originUsersId = [...this.$store.data.participatorUserId]
  //           this.$store.data.updateInfo = {
  //             updateType: '',
  //             isUpate: false
  //           }
  //           this.update()
  //         }).catch(err => {
  //           this.$store.data.participatorList = [...this.$store.data.originUsers]
  //           this.$store.data.participatorUserId = [...this.$store.data.originUsersId]
  //           this.$store.data.updateInfo = {
  //             updateType: '',
  //             isUpate: false
  //           }
  //           this.update()
  //         })
  //       }

  //       break
  //     case 'repeat':
  //       let repeatListMap = new Map()
  //       for (let item of this.data.comListData.repeatList) {
  //         if (item.recurrenceModel.recurrenceModel !== 'weekly') {
  //           repeatListMap.set(item.recurrenceModel.model, item.id)
  //         }
  //       }
  //       if (this.$store.data.originalData.repeatable === 0 && this.data.repeatable === 1) {
  //         let dataRepeat1 = {
  //           startTime: this.$store.data.startTime.replace(/\//g, "-"),
  //           endTime: this.$store.data.endTime.replace(/\//g, "-"),
  //           modifyModel: modifyModel,
  //           modifyContent: 'to_repeat',
  //           recurrenceModel: this.data.recurrenceModel,
  //           repeatable: this.data.repeatable
  //         }
  //         this.modifySchedule(dataRepeat1).then(res => {
  //           observer.notice(res.data.data)
  //           this.$store.data.originalData.recurrenceModel = this.data.recurrenceModel
  //           this.$store.data.originalData.repeatable = this.data.repeatable
  //           this.update()
  //         }).catch(err => {
  //           this.setData({
  //             'comListData.comSelectListId': this.$store.data.originalData.recurrenceModel.model === 'weekly' ? (this.$store.data.originalData.recurrenceModel.weekDayList.length > 1 ? 3 : 2) : repeatListMap.get(this.$store.data.originalData.recurrenceModel.model),
  //             repeatable: this.$store.data.originalData.repeatable,
  //             recurrenceModel: this.$store.data.originalData.repeatable ? { model: this.storer.data.originalData.recurrenceModel.model, daysOfMonth: this.$store.data.originalData.recurrenceModel.daysOfMonth, interval: 1, initialTime: this.$store.data.originalData.recurrenceModel.initialTime, terminateTime: this.$store.data.originalData.recurrenceModel.terminateTime, weekDayList: this.$store.data.originalData.recurrenceModel.weekDayList } : { model: 'no_repeat' }
  //           })
  //         })
  //       }
  //       else if (this.$store.data.originalData.repeatable === 1 && this.data.repeatable === 0) {
  //         let dataRepeat2 = {
  //           startTime: this.$store.data.startTime.replace(/\//g, "-"),
  //           endTime: this.$store.data.endTime.replace(/\//g, "-"),
  //           modifyModel: modifyModel,
  //           modifyContent: 'no_repeat',
  //           recurrenceModel: this.data.recurrenceModel,
  //           repeatable: this.data.repeatable
  //         }
  //         this.modifySchedule(dataRepeat2).then(res => {
  //           this.$store.data.originalData.recurrenceModel = this.data.recurrenceModel
  //           this.$store.data.originalData.repeatable = this.data.repeatable
  //           this.update()
  //         }).catch(err => {
  //           this.setData({
  //             'comListData.comSelectListId': this.$store.data.originalData.recurrenceModel.model === 'weekly' ? (this.$store.data.originalData.recurrenceModel.weekDayList.length > 1 ? 3 : 2) : repeatListMap.get(this.$store.data.originalData.recurrenceModel.model),
  //             repeatable: this.$store.data.originalData.repeatable,
  //             recurrenceModel: this.$store.data.originalData.repeatable ? { model: this.$store.data.originalData.recurrenceModel.model, daysOfMonth: this.$store.data.originalData.recurrenceModel.daysOfMonth, interval: 1, initialTime: this.$store.data.originalData.recurrenceModel.initialTime, terminateTime: this.$store.data.originalData.recurrenceModel.terminateTime, weekDayList: this.$store.data.originalData.recurrenceModel.weekDayList } : { model: 'no_repeat' }
  //           })
  //         })
  //       }
  //       else {
  //         let dataRepeat3 = {
  //           startTime: this.$store.data.startTime.replace(/\//g, "-"),
  //           endTime: this.$store.data.endTime.replace(/\//g, "-"),
  //           modifyModel: modifyModel,
  //           modifyContent: 'change_rule',
  //           recurrenceModel: this.data.recurrenceModel,
  //           repeatable: this.data.repeatable
  //         }
  //         this.modifySchedule(dataRepeat3).then(res => {
  //           this.$store.data.originalData.recurrenceModel = this.data.recurrenceModel
  //           this.$store.data.originalData.repeatable = this.data.repeatable
  //           this.update()
  //         }).catch(err => {
  //           this.setData({
  //             'comListData.comSelectListId': this.$store.data.originalData.recurrenceModel.model === 'weekly' ? (this.$store.data.originalData.recurrenceModel.weekDayList.length > 1 ? 3 : 2) : repeatListMap.get(this.$store.data.originalData.recurrenceModel.model),
  //             repeatable: this.$store.data.originalData.repeatable
  //           })
  //         })
  //       }
  //       break
  //     case 'modify_location':
  //       let dataLocation = {
  //         modifyModel: modifyModel,
  //         modifyContent: 'modify_location',
  //         location: {
  //           longitude: '-999',
  //           latitude: '-999',
  //           locationName: this.$store.data.locationName
  //         },
  //         meetingRoomId: !!this.$store.data.roomId ? this.$store.data.roomId : -1
  //       }
  //       this.modifySchedule(dataLocation, needNotice).then(res => {
  //         this.$store.data.originalData.location = {
  //           longitude: '-999',
  //           latitude: '-999',
  //           locationName: this.$store.data.locationName
  //         }
  //         this.$store.data.originalData.meetingRoomId = this.$store.data.roomId ? -1 : this.$store.data.roomId
  //         this.$store.data.updateInfo = {
  //           isUpate: false,
  //           updateType: ''
  //         }
  //         this.update()
  //         if (this.$store.data.startTime != this.$store.data.originalData.startTime.replace(/-/g, '/') || this.$store.data.endTime != this.$store.data.originalData.endTime.replace(/-/g, '/')) {
  //           let dat2Time1 = {
  //             modifyModel: modifyModel,
  //             startTime: this.$store.data.startTime.replace(/\//g, "-"),
  //             endTime: this.$store.data.endTime.replace(/\//g, "-"),
  //             modifyContent: 'modify_time'
  //           }
  //           this.isChange('modify_time', modifyModel, needNotice)

  //         }
  //       }).catch(err => {
  //         this.$store.data.locationName = this.$store.data.originalData.location.locationName
  //         this.$store.data.roomId = this.$store.data.originalData.meetingRoomId
  //         this.update()
  //       })
  //       break
  //     case 'modify_time':
  //       let data = {
  //         modifyModel: modifyModel,
  //         startTime: this.$store.data.startTime.replace(/\//g, "-"),
  //         endTime: this.$store.data.endTime.replace(/\//g, "-"),
  //         modifyContent: 'modify_time'
  //       }
  //       this.modifySchedule(data, needNotice).then(res => {
  //         this.$store.data.originalData.startTime = this.$store.data.startTime.replace(/\//g, "-")
  //         this.$store.data.originalData.endTime = this.$store.data.endTime.replace(/\//g, "-")
  //         this.update()
  //         this.resetRepeatList()
  //         if (this.data.recurrenceModel.model === 'weekly' && this.data.recurrenceModel.weekDayList.length === 1) {
  //           let dataRepeat4 = {
  //             startTime: this.$store.data.startTime.replace(/\//g, "-"),
  //             endTime: this.$store.data.endTime.replace(/\//g, "-"),
  //             modifyModel: modifyModel,
  //             modifyContent: 'change_rule',
  //             recurrenceModel: this.data.comListData.repeatList[2].recurrenceModel,
  //             repeatable: this.data.repeatable
  //           }
  //           this.modifySchedule(dataRepeat4).then(() => {
  //             this.setData({
  //               recurrenceModel: this.data.comListData.repeatList[2].recurrenceModel
  //             })
  //           })
  //         } else if (this.data.recurrenceModel.model === 'absolute_Monthly') {
  //           let dataRepeat5 = {
  //             startTime: this.$store.data.startTime.replace(/\//g, "-"),
  //             endTime: this.$store.data.endTime.replace(/\//g, "-"),
  //             modifyModel: modifyModel,
  //             modifyContent: 'change_rule',
  //             recurrenceModel: this.data.comListData.repeatList[4].recurrenceModel,
  //             repeatable: this.data.repeatable
  //           }
  //           this.modifySchedule(dataRepeat5).then(() => {
  //             this.setData({
  //               recurrenceModel: this.data.comListData.repeatList[4].recurrenceModel
  //             })
  //           })

  //         }
  //         // this.modifySchedule(data, needNotice)
  //       }).catch(err => {
  //         this.$store.data.startTime = this.$store.data.originalData.startTime.replace(/-/g, '/')
  //         this.$store.data.endTime = this.$store.data.originalData.endTime.replace(/-/g, '/')
  //         this.update()
  //         this.setData({
  //           week: this.data.weekList[new Date(this.$store.data.originalData.startTime.replace(/-/g, "/")).getDay()],
  //         })
  //       })
  //       break
  //     // case 'aheadTimes':
  //     //   let dataAheadTimes = {
  //     //     modifyModel: modifyModel,
  //     //     aheadTimes: this.data.aheadTimes,
  //     //     modifyContent: 'aheadTimes'
  //     //   }
  //     //   this.modifySchedule(dataAheadTimes).then(res => {
  //     //     this.$store.data.originalData.aheadTimes = (this.data.aheadTimes.length === 0 ? null : this.data.aheadTimes)
  //     //     this.update()
  //     //   }).catch(err => {
  //     //     this.setData({
  //     //       aheadTimes: this.$store.data.originalData.aheadTimes
  //     //     })
  //     //   })
  //     //   break
  //   }
  // },


  // 页面卸载
  onUnload() {
    // 页面被关闭
    observer.unregister()
  },

  //获取动态列表
  loadAffairList(current = 1) {
    // if (this.data.repeatable == 1) {
    //   if (!this.data.scheduleItem.groupId) {
    //     console.log(`groupId不存在`)
    //     return
    //   }
    //   this.getRepeatAffairList(this.data.scheduleItem.groupId, current)
    // } else {
    //   if (!this.data.scheduleItem.id) {
    //     console.log(`scheduleItem.id不存在`)
    //     return
    //   }
    //   this.getAffairList(this.data.scheduleItem.id)
    // }
    // //重置
    // this.store.data.isNeedReloadList = false;
    // this.update();

    this.getAffairList(this.store.data.scheduleId)


  },
  //获取单次会议动态列表
  getAffairList(id) {
    getMeetingRoomAffairs(id).then(res => {
      this.getTaskAndFiles(res.data.data);
      const newAffairList = this.dealAffairData(res.data.data || []);
      this.store.data.affairList = newAffairList;
      this.update();
      this.setData({
        affairLoading: false
      });
    })
  },
  //获取重复会议动态列表
  // getRepeatAffairList(groupId, current) {
  //   getMeetingRoomRepeatAffairs(groupId, current).then(res => {
  //     const newAffairList = this.dealRepeatAffairs(res.data.data.records || []);
  //     //第一页数据会重新请求需要替换
  //     if (current === 1) {
  //       this.store.data.affairList = newAffairList;
  //       this.update();
  //     } else {
  //       const newDynamicList = this.store.data.affairList.concat(newAffairList);
  //       this.store.data.affairList = newDynamicList;
  //       this.update();
  //     }
  //     this.setData({
  //       affairLoading: false,
  //       current: res.data.data.current,
  //       pages: res.data.data.pages
  //     });
  //   })
  // },
  //加载之前的会议动态
  // loadAffairMore() {
  //   if (this.data.current < this.data.pages) {
  //     this.loadAffairList(this.data.current + 1);
  //   }
  // },
  //处理重复会议动态数据
  // dealRepeatAffairs(affairList, type) {
  //   // const newAffairData = {};
  //   // const newAffairList = [];
  //   // affairList.forEach(it => {
  //   //   if (it.meetingLogResource) {
  //   //     newAffairData[it.resourceId] = []
  //   //   }
  //   // })
  //   return affairList.map(item => {
  //     let itemData = item.meetingLogResource;
  //     if (itemData) {
  //       if (item.createTime) {
  //         item.sort1 = item.createTime
  //         item.sort = new Date(item.createTime.replace(/-/g, '/')).getTime();
  //         item.createTime = getCreateShowTime(item.createTime);
  //       }
  //       if (itemData.acceptorInfo) {
  //         itemData.acceptorInfo = JSON.parse(itemData.acceptorInfo);
  //       }
  //       if (itemData.creatorInfo) {
  //         itemData.creatorInfo = JSON.parse(itemData.creatorInfo);
  //       }
  //       if (itemData.fileInfos) {
  //         item.fileView = {
  //           fileInfos: JSON.parse(itemData.fileInfos),
  //           creatorInfo: itemData.creatorInfo,
  //           id: itemData.id,
  //           description: itemData.description
  //         };
  //       }
  //       if (itemData.taskInfos) {
  //         item.taskViewList = [
  //           {
  //             acceptorInfo: itemData.acceptorInfo,
  //             acceptorId: itemData.acceptorId,
  //             creatorInfo: itemData.creatorInfo,
  //             creatorId: itemData.creatorId,
  //             taskInfos: JSON.parse(itemData.taskInfos),
  //             taskStatus: itemData.taskStatus,
  //             id: itemData.id
  //           }
  //         ]
  //       }

  //       // newAffairData[item.resourceId].push(item);
  //     }
  //     return item
  //   });
  //   // console.log(newAffairData);
  //   // for (let i in newAffairData) {
  //   //   newAffairData[i].sort((a, b) => a.sort - b.sort);
  //   //   newAffairList.push(newAffairData[i][0])
  //   // }
  //   // console.log(newAffairList)
  //   // return newAffairList.sort((a, b) => a.sort - b.sort);
  // },

  // 获取所有的任务和文件
  getTaskAndFiles(affairList) {
    const files = [];
    const tasks = [];
    affairList.forEach(it => {
      if (it.commentType === 'task') {
        tasks.push(it)
      } else if (it.commentType === 'file') {
        files.push(it)
      }
    })
    this.store.data.files = files;
    this.store.data.tasks = tasks;
    this.update();
  },
  //处理会议动态数据
  dealAffairData(affairList) {
    return affairList.map(it => {
      if (it.createTime) {
        it.updateTime = getCreateShowTime(it.updateTime);
      }
      if (it.replyCommentList) {
        it.replyCommentList.map(item => {
          item.updateTime = getCreateShowTime(item.updateTime);
          return item
        })
      }
      return it
    })
  },
  showPop(e) {
    this.setData({
      pop: e.target.dataset.pop,
      show: true
    })
  },
  // closePop() {
  //   this.setData({
  //     show: false
  //   });

  //   if (this.data.pop.type == 'updateTask') {
  //     const { currentTask } = this.store.data;
  //     const { oldTask } = this.data;

  //     //添加执行人
  //     if (!oldTask.acceptorId && currentTask.acceptorId) {
  //       this.addTaskExcutor();
  //     }
  //     ///删除执行人
  //     else if (oldTask.acceptorId && !currentTask.acceptorId) {
  //       this.deleteTaskExcutor();
  //     }
  //     //修改执行人
  //     else if ((oldTask.acceptorId && currentTask.acceptorId) && (oldTask.acceptorId !== currentTask.acceptorId)) {
  //       this.updateTaskExcutor();
  //     }
  //     //修改任务标题
  //     if (currentTask.taskInfos.taskTitle && currentTask.taskInfos.taskTitle !== oldTask.taskInfos.taskTitle) {
  //       this.editTaskTitle();
  //     }
  //     //修改任务状态
  //     if (currentTask.taskStatus !== oldTask.taskStatus) {
  //       this.changeTaskStatus();
  //     }

  //     //刷新列表,这里为什么不在promie后执行
  //     setTimeout(() => {
  //       if (this.store.data.isNeedReloadList) {
  //         this.loadAffairList();
  //         this.setData({
  //           'conToastData.showToast': true,
  //           'conToastData.title': '编辑成功',
  //         })
  //         this.$store.data.isIndexAffairListNeedUpdate = true;
  //         this.update();
  //       }
  //     }, 500)
  //   }
  // },
  //出现任务弹窗
  // showCreateTask(e) {
  //   //重置
  //   this.store.data.currentTask = {};
  //   this.update();
  //   this.showPop(e)
  // },
  //设置修改任务弹框中当前任务
  // setCurrentTask(currentTask) {
  //   this.setData({
  //     oldTask: JSON.parse(JSON.stringify(currentTask))
  //   })
  //   this.store.data.currentTask = currentTask;
  //   this.update();
  // },

  // 上传文件
  async handleAddFile() {
    this.store.data.description = '';
    this.store.data.fileInfos = null;
    const res = await getFileInfo();
    if (res.code === -1) {
      dd.alert({
        content: res.msg,
        buttonText: '确定'
      })
      return
    }
    let data = []
    res.data.map(it => {
      data.push({
        fileId: it.fileId,
        name: it.fileName,
        size: it.fileSize,
        spaceId: it.spaceId,
        platform: "dingTalk",
        mimeType: it.fileType
      })
    })

    this.store.data.fileInfos = data
    this.update()
    dd.navigateTo({ url: `./../uploadFile/uploadFile?id=${this.store.data.scheduleId}` })
  },

  //隐藏文件操作浮窗
  // hideFileOperate() {
  //   this.store.data.logId = '';
  //   this.update();
  // },
  // 删除文件
  // deleteMeetingFile(id) {
  //   this.updateTask({
  //     "logType": "schedule_accessory_remove",
  //     "resourceType": "accessory",
  //     "id": id
  //   }, () => {
  //     this.loadAffairList();
  //     this.$store.data.isIndexAffairListNeedUpdate = true;
  //     this.update();
  //   })
  // },
  // 删除执行人
  // deleteTaskExcutor() {
  //   this.updateTask({
  //     "logType": "task_remove_acceptor",
  //     acceptorInfo: JSON.stringify(this.data.oldTask.acceptorInfo),
  //     acceptorId: this.data.oldTask.acceptorId
  //   })
  // },
  // 添加执行人
  // addTaskExcutor() {
  //   this.updateTask({
  //     "logType": "task_add_acceptor",
  //     acceptorInfo: JSON.stringify(this.store.data.currentTask.acceptorInfo),
  //     acceptorId: this.store.data.currentTask.acceptorId
  //   })
  // },
  //修改执行人
  // updateTaskExcutor() {
  //   this.updateTask({
  //     "logType": "task_modify_acceptor",
  //     acceptorInfo: JSON.stringify(this.store.data.currentTask.acceptorInfo),
  //     acceptorId: this.store.data.currentTask.acceptorId
  //   })
  // },
  //修改任务标题
  // editTaskTitle(value) {
  //   this.updateTask({
  //     "logType": "task_modify_title",
  //     "taskInfos": JSON.stringify(this.store.data.currentTask.taskInfos)
  //   })
  // },
  //重复任务状态处理
  // dealRepeatStatus(task) {
  //   let dataIndex = "";
  //   this.data.affairList.forEach((item, index) => {
  //     if (item.meetingLogResource.id == task.id) {
  //       dataIndex = index;
  //     }
  //   });
  //   const setData = `affairList[${dataIndex}].taskViewList[0].taskStatus`;
  //   const setData2 = `affairList[${dataIndex}].meetingLogResource.taskStatus`;

  //   this.store.data[setData] = task.status;
  //   this.store.data[setData2] = task.status;
  //   this.update();
  // },
  //弹窗修改任务状态
  // changeTaskStatus() {
  //   this.updateTask({
  //     "logType": "task_status_modify",
  //     "taskStatus": this.store.data.currentTask.taskStatus
  //   }, () => {
  //     if (this.data.repeatable == 1) {
  //       this.dealRepeatStatus({ status: this.store.data.currentTask.taskStatus, id: this.store.data.currentTask.id });
  //     }
  //     this.store.data.isNeedReloadList = true;
  //     this.update();
  //   })
  // },
  //删除任务
  // deleteTask(id) {
  //   this.updateTask({
  //     "logType": "task_remove",
  //   }, () => {
  //     this.closePop();
  //     this.loadAffairList();
  //     this.$store.data.isIndexAffairListNeedUpdate = true;
  //     this.update();
  //   })
  // },
  //修改任务
  // updateTask(taskData, callBack) {
  //   const postData = {
  //     "groupId": this.data.scheduleItem.groupId,
  //     "scheduleId": this.data.scheduleItem.id,
  //     "resourceType": "task",
  //     "creatorId": getApp().globalData.userid,
  //     "creatorInfo": getApp().globalData.userInfo,
  //     "id": this.store.data.currentTask.id,
  //     ...taskData
  //   }
  //   updateMeetingTask(postData).then(res => {
  //     if (res.data.code == 0) {
  //       if (callBack) {
  //         callBack();
  //       } else {
  //         this.store.data.isNeedReloadList = true;
  //         this.update();
  //       }
  //     }
  //   })
  // },
  //创建任务
  // complete: throttle(function () {
  //   const { currentTask } = this.store.data;
  //   const postData = {
  //     "groupId": this.data.scheduleItem.groupId,
  //     "scheduleId": this.data.scheduleItem.id,
  //     "resourceType": "task",
  //     "creatorId": getApp().globalData.userid,
  //     "creatorInfo": getApp().globalData.userInfo,
  //     "logType": "task_add",
  //     "taskInfos": JSON.stringify(currentTask.taskInfos),
  //     "taskStatus": '0',
  //     "description": ""
  //   }
  //   if (currentTask.acceptorId) {
  //     postData.acceptorId = currentTask.acceptorId;
  //     postData.acceptorInfo = JSON.stringify(currentTask.acceptorInfo);
  //   }
  //   createMeetingTask(postData).then(res => {
  //     if (res.data.code == 0) {
  //       this.loadAffairList();
  //       this.closePop();
  //       this.setData({
  //         'conToastData.showToast': true,
  //         'conToastData.title': '保存成功',
  //       })
  //       //重置
  //       this.store.data.currentTask = {};
  //       this.update();

  //       this.$store.data.isIndexAffairListNeedUpdate = true;
  //       this.update();
  //     }
  //   })
  // }),
  expand() {
    this.setData({
      isExpand: false
    })
  },
  setCopy(event) {
    if (event.currentTarget.dataset.type) {
      dd.setClipboard({
        text: event.currentTarget.dataset.item,
        success: res => {
          dd.alert({
            buttonText: '确定',
            content: '复制成功，请在外部浏览器打开'
          })
        }
      })
    } else {
      dd.setClipboard({
        text: event.currentTarget.dataset.item,
        success: res => {
          this.setData({
            'conToastData.showToast': true,
            'conToastData.title': '复制成功',
          });

        }
      })
    }
  },
  //修改任务状态
  changeTaskStatus(e) {
    const data = {
      meetingId: this.store.data.scheduleId,
      platform: 'dingTalk',
      taskModifyModel: {
        commentId: e.commentId,
        processState: e.status,
        taskId: e.taskId
      }
    };
    updateMeetingTask(data).then(res => {
      if (res.data.code === 0) {
        const [index] = this.getIndexFromAffairList(e.commentId);
        if (index !== -1) {
          this.store.data.affairList[index].meetingTaskSimpleViewModel.processState = e.status;
          this.store.data.affairList[index].updateTime = getCreateShowTime(new Date());
        }
        this.update();
      }
    });
  },
  // 创建任务
  goCreateTask(e) {
    dd.navigateTo({ url: '/pages/createTask/createTask?meetingId=' + this.store.data.scheduleId })
  },
  // 创建会议笔记
  openNoteModal() {
    this.setData({
      popup: {
        show: true,
        title: '创建会议笔记',
        mask: true,
        type: 'notesModal'
      }
    })
    // this.setData({
    //   popupShow: true,
    //   popupTitle: '创建会议笔记',
    //   comType: 'notesModal'
    // })
  },
  // 编辑笔记
  editNotes(e) {
    this.store.data.notes = e.currentTarget.dataset;
    this.update();
    this.setData({
      popup: {
        show: true,
        title: '编辑会议笔记',
        mask: true,
        type: 'notesModal'
      }
    })

  },
  getNotes(notes) {
    //编辑
    if (this.store.data.notes) {
      updateMoment({
        ...this.store.data.notes,
        platform: 'dingTalk',
        notice: true,
        meetingNotes: notes,
        meetingId: this.store.data.scheduleId
      }).then(res => {
        if (res.data.code == 0) {
          this.closePopup1();
          // clear
          this.store.data.notes = null;
          this.update();
        }
      })
      return
    }
    //创建
    updateMeetingTask({
      platform: 'dingTalk',
      notice: true,
      meetingId: this.store.data.scheduleId,
      notesModel: {
        meetingNotes: notes
      }
    }).then(res => {
      if (res.data.code == 0) {
        this.getAffairList(this.store.data.scheduleId);
        this.closePopup1();
      }
    })
  },
  //添加评论
  openComentModal(e) {
    console.log(e)
    this.store.data.parentCommentId = e.currentTarget.dataset.commentId;
    this.update();
    this.setData({
      popup: {
        show: true,
        title: '添加评论',
        mask: true,
        type: 'remarkModal'
      }
    })
  },
  getComment(comment) {
    updateMeetingTask({
      parentCommentId: this.store.data.parentCommentId,
      platform: 'dingTalk',
      remark: comment,
      notice: false,
      meetingId: this.store.data.scheduleId,
    }).then(res => {
      if (res.data.code == 0) {
        this.getAffairList(this.store.data.scheduleId);
        // clear
        this.store.data.parentCommentId = '';
        this.update();
        this.closePopup1();
      }
    })
  },
  // 删除动态
  handleDeleteMoment(e) {
    this.deleteComment(e.currentTarget.dataset.commentId)
  },
  // 有parentCommentId删除评论，无则删除动态
  deleteComment(commentId, parentCommentId) {
    dd.confirm({
      title: '删除',
      content: '确认要删除吗？',
      confirmButtonText: '确定',
      cancelButtonText: '取消',
      success: (res) => {
        if (res.confirm) {
          deleteMoment(commentId).then(res => {
            if (res.data.code === 0) {
              if (parentCommentId) {
                const [index, childIndex] = this.getIndexFromAffairList(parentCommentId, commentId);
                if (childIndex[1] !== -1) {
                  this.store.data.affairList[index].replyCommentList.splice(childIndex, 1);
                } else {
                  this.store.data.affairList[index].splice(index, 1);
                }
                this.update();
              }
            }
          })
        }
      }
    })
  },
  //修改描述
  openRemarkModal(e) {
    this.store.data.remark = e.currentTarget.dataset;
    this.update();
    this.setData({
      popupShow: true,
      popupTitle: '添加描述',
      comType: 'remarkModal'
    })
  },
  getRemark(remark) {
    const commentId = this.store.data.remark.commentId;
    updateMoment({
      commentId,
      remark,
      platform: 'dingTalk',
      notice: true,
    }).then(res => {
      if (res.data.code == 0) {
        this.closePopup1();
        const [index] = this.getIndexFromAffairList(commentId);
        if (index !== -1) {
          this.store.data.affairList[index].remark = remark;
          this.store.data.affairList[index].updateTime = getCreateShowTime(new Date());
        }
        // clear
        this.store.data.remark = null;
        this.update();
      }
    })
  },
  getIndexFromAffairList(parentCommentId, commentId) {
    const index = this.store.data.affairList.findIndex(it => it.commentId === parentCommentId);
    let childIndex = -1;
    if (index !== -1) {
      if (commentId) {
        childIndex = this.store.data.affairList[index].replyCommentList.findIndex(it => it.commentId === commentId)
      }
    }
    return [index, childIndex];
  },
  goTasksPage() {
    dd.navigateTo({ url: '/pages/tasks/tasks?meetingId=' + this.store.data.scheduleId })
  },
  goFilesPage() {
    dd.navigateTo({ url: '/pages/files/files?meetingId=' + this.store.data.scheduleId })
  }
});

